<script setup lang="ts">
import { useAppStore } from '~/stores/app';

const app = useAppStore()
await callOnce(app.fetchUserData);

// domain.com/#tgWebAppData
const isFromOutsideTg = !window?.location?.href.includes('tgWebAppData');

// implement breadcrumb

interface BreadcrumbItem {
    path: string;
    name: string;
}

const route = useRoute();
const ticketId = computed(() => route?.params?.id);
const breadcrumbItems = new Map<String, BreadcrumbItem[]>();
breadcrumbItems.set('/', []);
breadcrumbItems.set('/routing', [
    { path: '/routing', name: 'Espace de routage' }
]);
breadcrumbItems.set('routing-id', [
    { path: '/routing', name: 'Espace de routage' },
    { path: '/routing/' + ticketId?.value, name: 'Ticket #' + ticketId?.value }
]);
breadcrumbItems.set('routing-id-users', [
    { path: '/routing', name: 'Espace de routage' },
    { path: '/routing/' + ticketId?.value, name: 'Ticket #' + ticketId?.value },
    { path: '/routing/' + ticketId?.value + '/users', name: 'Utilisateurs' }
]);
</script>

<template>
    <nav class="bg-white border-gray-200 dark:bg-gray-900">
        <div class="max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4">
            <NuxtLink href="/" class="flex items-center space-x-3 rtl:space-x-reverse">
                <span class="self-center text-2xl font-semibold whitespace-nowrap dark:text-white">AGEP Support</span>
            </NuxtLink>
            <div class="flex items-center md:order-2 space-x-3 md:space-x-0 rtl:space-x-reverse">
                <button type="button"
                    class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    id="user-menu-button" aria-expanded="false" data-dropdown-toggle="user-dropdown"
                    data-dropdown-placement="bottom">
                    S. Lefort
                </button>
                <!-- Dropdown menu -->
                <div class="z-50 hidden my-4 text-base list-none bg-white divide-y divide-gray-100 rounded-lg shadow dark:bg-gray-700 dark:divide-gray-600"
                    id="user-dropdown">
                    <div class="px-4 py-3">
                        <span class="block text-sm text-gray-900 dark:text-white">Simon Lefort</span>
                        <span
                            class="block text-sm  text-gray-500 truncate dark:text-gray-400">simon.lefort@epfl.ch</span>
                    </div>
                    <ul class="py-2" aria-labelledby="user-menu-button">
                        <li>
                            <NuxtLink to="/routing"
                                class="block px-4 py-2 text-sm text-gray-700 hover:bg-gray-100 dark:hover:bg-gray-600 dark:text-gray-200 dark:hover:text-white">
                                Espace de routage
                            </NuxtLink>
                        </li>
                        <li>
                            <a href="#"
                                class="block px-4 py-2 text-sm text-gray-700 hover:bg-gray-100 dark:hover:bg-gray-600 dark:text-gray-200 dark:hover:text-white">Sign
                                out</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </nav>

    <nav class="max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4" aria-label="Breadcrumb">
        <ol class="inline-flex items-center space-x-1 md:space-x-2 rtl:space-x-reverse">
            <li class="inline-flex items-center">
                <NuxtLink to="/"
                    class="inline-flex items-center text-sm font-medium text-gray-700 hover:text-blue-600 dark:text-gray-400 dark:hover:text-white">
                    <svg class="w-3 h-3 me-2.5" aria-hidden="true" xmlns="http://www.w3.org/2000/svg"
                        fill="currentColor" viewBox="0 0 20 20">
                        <path
                            d="m19.707 9.293-2-2-7-7a1 1 0 0 0-1.414 0l-7 7-2 2a1 1 0 0 0 1.414 1.414L2 10.414V18a2 2 0 0 0 2 2h3a1 1 0 0 0 1-1v-4a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1v4a1 1 0 0 0 1 1h3a2 2 0 0 0 2-2v-7.586l.293.293a1 1 0 0 0 1.414-1.414Z" />
                    </svg>
                    Accueil
                </NuxtLink>
            </li>
            <li aria-current="page"
                v-for="(bcItem, index) in breadcrumbItems.get($route.matched[0]?.name as string || '/')" :key="index"
                class="breadcrumb-item" :class="{ active: index === $route.matched.length - 1 }">
                <div class="inline-flex items-center">
                    <NuxtLink :to="bcItem.path"
                        class="inline-flex items-center text-sm font-medium text-gray-700 hover:text-blue-600 dark:text-gray-400 dark:hover:text-white">
                        <svg class="rtl:rotate-180 w-3 h-3 text-gray-400 mx-1" aria-hidden="true"
                            xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 6 10">
                            <path stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
                                d="m1 9 4-4-4-4" />
                        </svg>
                        <span class="ms-1 text-sm font-medium text-gray-500 md:ms-2 dark:text-gray-400">{{ bcItem.name
                            }}</span>
                    </NuxtLink>
                </div>
            </li>
        </ol>
    </nav>


    <div class="content pt-4 ml-10 mr-10 mb-28">
        <slot />
    </div>

</template>
